#include <iostream>
#include <string>

#include <boost/algorithm/string.hpp>
#include <boost/lexical_cast.hpp>

using namespace std;
using namespace boost;

struct _test_value {
	const char *_char;
	const wchar_t *_wchar;
};
static _test_value double_test[] =
{
	{	"hello world!123"	,	L"hello world!123"	},
	{	"12345"	,	L"12345"	},
	{	" 12345"	,	L" 12345"	},
	{	"12345 "	,	L"12345 "	},
	{	" 12345 "	,	L" 12345 "	},
	{	"123.45"	,	L"123.45"	},
	{	"6.543E+099"	,	L"6.543E+099"	},
	{	"6.543e+099"	,	L"6.543e+099"	},
	{	"1.2345e+999"	,	L"1.2345e+999"	},

	//	stopper
	{ NULL,NULL }
};

int main(int argc, char *argv[])
{
	string str1;
	wstring str2;
	
	double db;
	int ni=0;
	cout << "== double convert"  << endl;

	while(double_test[ni]._char!=NULL){
		
		str1=double_test[ni]._char;
		str2=double_test[ni]._wchar;

		try{
			db=lexical_cast<double>(str1);
			cout << str1 << ":"<< db << endl;
		} catch(bad_lexical_cast &e) {
			cout << str1 << "(error):" << e.what() << endl;
		}

		try{
			db=lexical_cast<double>(str2);
			cout << str1 << ":"<<  db << endl;
		} catch(bad_lexical_cast &e) {
			cout << str1 << "(error):"  << e.what() << endl;
		}

		std::istringstream ss(str1);
		//std::wistringstream ss(str2);
		ss >> db;
		if(!(ss && (ss >> std::ws).eof())){
			cout << "cast(error):"<< str1 <<  ":"<<  db << endl;
		} else {
			cout << "cast:"<< str1 <<  ":"<<  db << endl;
		}

		db=atof(str1.c_str());
		cout << "atof:"<< str1 << ":"<<  db << endl;
		cout << endl;
		ni++;
	}
	int nb;
	ni=0;
	cout << "== int convert"  << endl;
	while(double_test[ni]._char!=NULL){
		
		str1=double_test[ni]._char;
		str2=double_test[ni]._wchar;

		try{
			nb=lexical_cast<int>(str1);
			cout << str1 << ":"<< nb << endl;
		} catch(bad_lexical_cast &e) {
			cout << str1 << "(error):" << e.what() << endl;
		}

		try{
			nb=lexical_cast<int>(str2);
			cout << str1 << ":"<<  nb << endl;
		} catch(bad_lexical_cast &e) {
			cout << str1 << "(error):"  << e.what() << endl;
		}

		std::istringstream ss(str1);
		ss >> nb;
		if(!(ss && (ss >> std::ws).eof())){
			cout << "cast(error):"<< str1 << ":"<<  nb << endl;
		} else {
			cout << "cast:"<< str1 << ":"<<  nb << endl;
		}

		nb=atoi(str1.c_str());
		cout << "atoi:"<< str1 << ":"<<  nb << endl;
		cout << endl;
		ni++;
	}


	string strss;
	cin >> strss ;	//	any key input!! -> exit.
	return 1;
}

